package com.zt.plat.module.base.service.base;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.api.dto.ElementDTO;
import com.zt.plat.module.base.controller.admin.base.vo.ElementPageReqVO;
import com.zt.plat.module.base.controller.admin.base.vo.ElementRespVO;
import com.zt.plat.module.base.controller.admin.base.vo.ElementSaveReqVO;
import com.zt.plat.module.base.dal.dataobject.base.ElementDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 金属元素 Service 接口
 *
 * @author 后台管理
 */
public interface ElementService {

    /**
     * 创建金属元素
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ElementRespVO createElement(@Valid ElementSaveReqVO createReqVO);

    /**
     * 更新金属元素
     *
     * @param updateReqVO 更新信息
     */
    void updateElement(@Valid ElementSaveReqVO updateReqVO);

    /**
     * 删除金属元素
     *
     * @param id 编号
     */
    void deleteElement(Long id);

    /**
    * 批量删除金属元素
    *
    * @param ids 编号
    */
    void deleteElementListByIds(List<Long> ids);

    /**
     * 获得金属元素
     *
     * @param id 编号
     * @return 金属元素
     */
    ElementDO getElement(Long id);

    /**
     * 获得金属元素分页
     *
     * @param pageReqVO 分页查询
     * @return 金属元素分页
     */
    PageResult<ElementDO> getElementPage(ElementPageReqVO pageReqVO);

    void enableElementList(List<ElementRespVO> saveReqVOS);

    List<ElementDO> getElementNoPage();

    PageResult<ElementDO> getElementPageByEnable(ElementPageReqVO pageReqVO);
    /**
     * 根据元素符号获得元素
     *
     * @param symbol 元素符号
     * @return 元素
     */
    ElementDO getElementBySymbol(String symbol);
}